//
// TwitterFox sync settings window
//
// Copyright (c) 2009 Kazuho Okui / naan studio, Inc. ALL RIGHTS RESERVED.
//

const Cc = Components.classes;
const Ci = Components.interfaces;

const TwitterFoxSync = {
  onload: function() {
    var pref = Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefBranch);
    this.syncServer = pref.getCharPref("extensions.twitternotifier.syncServer");

    var JSON = Components.classes["@mozilla.org/dom/json;1"].createInstance(Components.interfaces.nsIJSON);
    var token = JSON.decode(pref.getCharPref("extensions.twitternotifier.token"));
    this.twitter_id = token[window.username].user_id;

    this.browser = document.getElementById('browser');
    this.browser.addProgressListener(this, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
    this.browser.setAttribute('src', this.syncServer + "?twitter_id=" + this.twitter_id);
  },

  onunload: function() {
  },

  onStateChange: function(progress, request, flag, status) {
    var channel;
    try {
      channel = request.QueryInterface(Components.interfaces.nsIHttpChannel);
    }
    catch (e) {
      return;
    }

    if (channel == null) return;

    if(flag & Ci.nsIWebProgressListener.STATE_STOP &&
       flag & Ci.nsIWebProgressListener.STATE_IS_DOCUMENT) {

      var serverURI = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService).newURI(this.syncServer, null, null);
      if (serverURI.host == channel.URI.host) {
        try {
          var key = channel.getResponseHeader('X-Echofon-Sess');
          if (this.twitter_id != channel.getResponseHeader('X-Twitter-Id')) {

            var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
            prompt.alert(window, "You authorized different twitter account. Please retry.");
            this.browser.loadURI(this.syncServer + "?twitter_id=" + this.twitter_id);
            key = null;
          }
        }
        catch (e) {}
        if (key) {
          //dump(channel.URI.spec + ' ' + flag + ' / Secret key = ' + key + "\n");
          var notifier = Components.classes['@naan.net/twitternotifier;1'].getService(Components.interfaces.nsITwitterFox);
          notifier.setSyncKey(window.username, key);
          var strings = document.getElementById("twitternotifier-strings");
          window.syncButton.setAttribute("label", strings.getString("disableSync"));
          window.setTimeout("window.close()", 2000);
        }
      }
    }
  },

  onLocationChange: function(aProgress, aRequest, URI) {
    this.URI = URI;
  },

  onProgressChange: function(aWebProgress, aRequest, curSelf, maxSelf, curTot, maxTot) {},
  onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) {},
  onSecurityChange: function(aWebProgress, aRequest, aState) {},

  QueryInterface: function (aIID) {
    if (aIID.equals(Components.interfaces.nsIWebProgressListener)   ||
        aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
        aIID.equals(Components.interfaces.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  }
};
